#!/bin/python

import re, sys, string
from FunkClient import *
from IRCClient import *

class FunkBot:
    def __init__(self, config):
        self.lastsong = None
        self.client = FunkClient(config)

    def main(self):
        self.nick = self.client.config["ircnick"]
        self.irc = IRCClient(self.client.config["ircserver"], string.atoi(self.client.config["ircport"]), self.nick, None, "funkbot", "stue407.ukc.ac.uk", "FunkBot", self.callback)
        self.channel = self.client.config["ircchannel"]
        self.irc.join(self.channel)
        nickre = re.compile("^" + self.nick + "[:,-]\s*(.*)$", re.IGNORECASE)
        while 1:
            result = self.irc.listen()
            if result[0] == "say":
                sendnick = result[1]
                receiver = result[2]
                text = result[3]
                match = nickre.match(text)
                if not match: continue
                cmd = match.group(1).split(" ", 1)
                if cmd[0] == "":
                    self.irc.say(self.channel, "Yeah?")
                elif cmd[0] == "playing":
                    song = self.get_playing()
                    if song:
                        self.irc.say(self.channel, "Current song is " + song)
                    else:
                        self.irc.say(self.channel, "Not playing anything")
                else:
                    self.irc.say(self.channel, "Sorry, I don't know what you mean.")

    def get_playing(self):
        songs = self.client.playing()
        song = None
        if len(songs):
            song = songs[0].get_title() + " - " + songs[0].get_artist()
        return song

    def callback(self):
        song = self.get_playing()
        if song != self.lastsong:
            self.lastsong = song
            if song:
                self.irc.say(self.channel, "Playing: " + song)
            else:
                self.irc.say(self.channel, "Not playing anything")

if __name__ == "__main__":
    f = FunkBot(sys.argv[1])
    f.main()

